
/* 
 * @(#)devinfo.c (c) 1995 j. g. geiger 
 * 
 * 
 */

#include	<stdio.h>
#include	<osbind.h>
#include	<file.h>

XATTR	xat;

char dev[80] = "U:\\dev\\";

char	*devname = "ttya";

short tf_stop = 0, tf_par = 0, tf_bit = 0, tf_flowctl = 0;

int setbaud = FALSE, setflow = FALSE  , settf = FALSE, unset_DTR = FALSE;

int verbose = FALSE;

void usage()
{
	printf("devinfo\t(c)1995 jerry g geiger\n\tget or set device parameters:\n");
	printf("devinfo [-h] [-v] [-b baud] [-{8765}{NEO}{1|1.5|2}]\n\t [-{RTS|XON|NONE}] -DTR [device]\n");
	printf("example:\n\tdevinfo ttya -b 19200 -8N1 -RTS -DTR\n");
}				

void badarg()
{
	fprintf(stderr, "devinfo: bad argument(s)\ntry 'devinfo -h'\n");
	exit(2);
}


void printflags( ushort flags)
{
	char *arg;

		if (flags & O_SHMODE) {
			switch(flags & O_SHMODE) {
				case O_DENYRW:
					arg = ", O_DENYRW";
					break;
				case O_DENYW:
					arg = ", O_DENYW";
					break;
				case O_DENYR:
					arg = ", O_DENYR";
					break;
				case O_DENYNONE:
					arg = ", O_DENYNONE";
					break;
				default:
					arg = "";
				}
		} else
			arg = ", O_COMPAT";
		printf("\t %s%s%s%s%s %s %s%s%s%s\n",
		(flags & O_RWMODE) ? (flags & O_WRONLY ? "O_WRONLY" : "O_RDWR") : "O_RDONLY",
		(flags & O_APPEND) ? ", O_APPEND" : "",
		arg,
		(flags & O_NOINHERIT) ? ", O_NOINHERIT" : "",
		(flags & O_NDELAY) ? ", O_NDELAY" : "",
		(flags & (O_GLOBAL|O_TTY|O_HEAD|O_LOCK)) ? "\n\t" : "",
		(flags & O_GLOBAL) ? ", O_GLOBAL" : "",
		(flags & O_TTY) ? ", O_TTY" : "",
		(flags & O_HEAD) ? ", O_HEAD" : "",
		(flags & O_LOCK) ? ", O_LOCK" : "" );
}

void printttyflags(ushort flags)
{
	int i;

		printf(" flags: %x %b\n", flags, flags);
		printf("\t TF_NLOCAL/TF_CAR: %d", flags & TF_NLOCAL ?  1 : 0);
		printf("\t TF_BRKINT: %d\n", flags & TF_BRKINT ?  1 : 0);
		i = flags & TF_STOPBITS;
		printf("\t TF_STOPBITS: %s", i & TF_1STOP ? "1" : (i & TF_15STOP ? "1.5" : "2"));
		i = flags & TF_CHARBITS;
		printf("\t TF_CHARBITS: %d\n", i & TF_7BIT ? 7 : (i & TF_6BIT ? 6 : (i & TF_5BIT ? 5 : 8)));
		printf("\t TF_FLAGS: %x : %s parity, flow control %s%s%s\n", 
				flags & TF_FLAGS, 
				flags & (T_EVENP|T_ODDP) ? (flags & T_EVENP ? "EVEN" : "ODD") : "NO",
				flags & T_TANDEM ? "Xon/Xoff" : "",
				flags & T_RTSCTS ? "RTS/CTS"  : "",
				flags & (T_RTSCTS|T_TANDEM) ? "" : "NONE");
}

main(argc, argv)
int	argc;
char	*argv[];
{

	short fh, i;
	long	count, baud = 0L, rval;
	ushort	flags;
	char 	*arg, c;
		
	while ((argc > 1) && *argv++) {
		arg = *argv;
		argc--;
		if(*arg == '-') {
			arg++;
			switch (*arg) {
			case 'v':
				verbose = TRUE;
				break;
			case 'h':
				usage();
				return(0);
				break;
			case 'D':
				unset_DTR = TRUE;
				break;
			case '8':
			case '7':
			case '6':
			case '5':
				settf = TRUE;
				switch(*arg++) {
				case '8':
					tf_bit = 0;
					break;
				case '7':
					tf_bit = TF_7BIT;
					break;
				case '6':
					tf_bit = TF_6BIT;
					break;
				case '5':
					tf_bit = TF_5BIT;
					break;
				default:
					badarg();
				}
				switch(*arg++) {
				case 'N':
					tf_par = 0;
					break;
				case 'E':
					tf_par = T_EVENP;
					break;
				case 'O':
					tf_par = T_ODDP;
					break;
				default:
					badarg();
				}
				switch(*arg++) {
				case '1':
					if(!*arg)
						tf_stop = TF_1STOP;
					else if ((*arg++ == '.') && (*arg == '5'))
						tf_stop = TF_15STOP;
					else
						badarg();
					break;
				case '2':
					tf_stop = TF_2STOP;
					break;
				default:
					badarg();
				}
				break;
			case 'R':
			case 'X':
			case 'N':
				setflow = TRUE;
				if(!strncmp(arg, "RTS", 3))
					tf_flowctl = T_RTSCTS;
				else if(!strncmp(arg, "XON", 3) || (!strncmp(arg, "Xon", 3)))
					tf_flowctl = T_TANDEM;
				else if(!strcmp(arg, "NONE"))
					tf_flowctl = 0;
				else
					badarg();
				break;
				break;
			case 'b':
				setbaud = TRUE;
				if(!*++arg) {
					arg = *++argv;
					argc--;
				}
				if(!(baud = (long)atol(arg)))
					badarg();
				break;
			}
		} else {
			devname = arg;
		}
	}

	strcat(dev, devname);

	if (setbaud || setflow || settf || unset_DTR) {
		if(verbose)
			printf("set /dev/%s\n", devname);
	} else {
		printf("get /dev/%s\n", devname);
		verbose = TRUE;
	}
		
	fh = Fopen(dev, O_RDONLY|O_DENYRW);
	if(verbose)
		printf( "dev open O_RDONLY|O_DENYRW %s %d\n",
					(fh < -3 ? "failed:" : "handle:"), fh);
	if(fh < -3)
		return(1);
	
	if(setbaud || setflow || settf || unset_DTR) {
		if(setflow && settf)
			flags = tf_stop|tf_par|tf_bit|tf_flowctl;
		else if(setflow || settf) {
			if (Fcntl( fh, &flags, TIOCGFLAGS))
				return(1);
			if(setflow) {
				flags &= ~TF_FLAGS;
				flags |= tf_flowctl;
			}
			if(settf) {
				flags &= TF_FLAGS;
				flags |= tf_stop|tf_par|tf_bit;
			}
		}
		if(setflow || settf) {
			rval = Fcntl( fh, &flags, TIOCSFLAGS);
			if(verbose)
				printf("set TF_FLAGS: Fcntl TIOCSFLAGS %ld\n",
				rval);	
		}
		if(setbaud) {
			count = baud;
			rval = Fcntl( fh, &count, TIOCIBAUD);	
			rval = Fcntl( fh, &count, TIOCOBAUD);	
			if(verbose)
				printf("Fcntl TIOCOBAUD set Baud: %ld %ld\n", baud,
					rval);	
			if(verbose)
				printf("\t returned speed: %ld\n", count);
		}
		if(unset_DTR) {
			count = 0L;		/* clr DTR */
			Fcntl( fh, &count, TIOCOBAUD);	
			rval = 0;
		}
		return(rval ? 1 : 0);	
	}

	/* show	*/

	Fcntl( fh, &xat, FSTAT);
	if(!(xat.rdev & 0xff00))
		arg = "BIOS_DRIVE_RDEV";
	else {
		switch((xat.rdev & 0xff00)) {
		case BIOS_RDEV:
			arg = "BIOS_RDEV";
			break;
		case FAKE_RDEV:
			arg = "FAKE_RDEV";
			break;
		case PIPE_RDEV:
			arg = "PIPE_RDEV";
			break;
		case UNK_RDEV:
			arg = "UNK_RDEV";
			break;
		case PROC_RDEV_BASE:
			arg = "PROC_RDEV_BASE";
			break;
		default:
			arg = "??";
		}
	}			
	printf("\tis %s: %07.7o, rdev: %s : %d \n", 
			(xat.mode & S_IFMT) == S_IFCHR ? "S_IFCHR" : "other",
			xat.mode, arg, (xat.rdev & 0xff));
	
	rval = Fcntl(fh, &count, F_GETFL);
	if(rval != -32) {
		printf("Fcntl F_GETFL : %ld\n", rval);
		flags = (ushort) rval;
		printflags(flags);
	}
	printf("Fcntl FIONREAD %ld\t",
		Fcntl( fh, &count, FIONREAD));
		printf(" count: %ld\n", count);
	printf("Fcntl FIONWRITE %ld\t",
		Fcntl( fh, &count, FIONWRITE));
		printf(" count: %ld\n", count);

	/* count <0 get speed, > 0 set speed , == 0 switch DTR return:
		ERANGE : in speed next lower possible one */
	count = -1L;	/* get speed */
	printf("Fcntl TIOCIBAUD %ld\t",
		rval = Fcntl( fh, &count, TIOCIBAUD));	
	if(rval)
		printf("\n");
	else
		printf(" speed: %ld\n", count);


	flags = 0;
	printf("Fcntl TIOCGFLAGS %ld\t",
 		rval = Fcntl( fh, &flags, TIOCGFLAGS));	
	if(rval != -32L) {
		printttyflags(flags);
		i = flags;
		flags |= (TF_CAR|TF_BRKINT);
		printf("Fcntl TIOCSFLAGS %ld\n",
			rval = Fcntl(fh, &flags, TIOCSFLAGS));	
		rval = Fcntl(fh, &flags, TIOCGFLAGS);
		if( (flags & (TF_CAR|TF_BRKINT)) == (TF_CAR|TF_BRKINT))
			printttyflags(flags);
		
		printf(" does%s support TF_CAR, does%s support TF_BRKINT\n",
				(flags & TF_CAR) == TF_CAR ? "" : "n't",
				(flags & TF_BRKINT) == TF_BRKINT ? "" : "n't" );
		flags = i;	/* reset	*/
		rval = Fcntl(fh, &flags, TIOCSFLAGS);
	} else
		printf("\n");
	count = 0L;
	printf("Fcntl TIOCGSTATE %ld\t",
		rval = Fcntl( fh, &count, TIOCGSTATE));	
	if(rval != -32L) {
		printf(" state: %lx %lb\n", count, count);
		printf("\t state: TS_BLIND %c", count & TS_BLIND ? '1' : '0');
		printf("\t state: TS_HOLD %c\n", count & TS_HOLD ? '1' : '0');
		printf("\t state: TS_HPCL %c", count & TS_HPCL ? '1' : '0');
		printf("\t state: TS_COOKED %c\n", count & TS_COOKED ? '1' : '0');
	} else
		printf("\n");
	

	Fclose(fh);
	return(0);


}	/* main	*/

