/* 
 * @(#)rsvfdevs.c (c) 1995 j. g. geiger
 * 
 * 
 */

#include	<stdio.h>

typedef struct Rsvf {
	union {
	char *name;
	struct Rsvf *next;
	}p;
	uchar drv;
#define ISDEV	0x80
#define ISGEMDOSDEV	0x40
#define ISBIOSDEV	0x20
#define HASMAGFUNP	0x01
	uchar res1;
	uchar devno;
	uchar res2;
} RSVF;

typedef struct MagiCDEVDRV {
	long (* mdev_open)();
	long (* mdev_close)();
	long (* mdev_read)();
	long (* mdev_write)();
	long (* mdev_stat)();
	long (* mdev_lseek)();
	long (* mdev_datime)();	/* darf 0-ptr sein	*/
	long (* mdev_ioctl)();
	long (* mdev_delete)();
	long (* mdev_getc)();	/* darf 0-ptr sein	*/
	long (* mdev_getline)();	/* darf 0-ptr sein	*/
	long (* mdev_putc)();	/* darf 0-ptr sein	*/
} MAGICDEVDRV;

main(argc, argv)
int	argc;
char	*argv[];
{
	MAGICDEVDRV *magfuns;
	RSVF *rsvf = NULL;

	if(argc >1) {
		argv++;
		if( (!strcmp(*argv,"-V")) || (!strcmp(*argv,"-h")) ) {
			printf("showRSVF   print existing RSVF device drivers (stdout)\n"
					"\t-V print this info and exit\n"
					"\t-v show drivers' function tables too\n");
			return(0);
		}
	}
	if(Getcookie('RSVF', &rsvf))
		printf("RSVF cookie found: %p\n", rsvf);
	else {
		if(Getcookie('RSVf', &rsvf))
			printf("RSVf cookie found: %p\n", rsvf);
		else
			return(0);
		}

  do {
  	
	while(rsvf->drv & ISDEV) {
		printf("entry:\n\t%s\n\tdrvmode %x\n\tfor dev no: %d\n",
				rsvf->p.name, rsvf->drv, rsvf->devno);
		printf("\t%s%s%s\n",
				rsvf->drv & ISGEMDOSDEV ? "is Gemdos device\n\t": "",
				rsvf->drv & ISBIOSDEV ?   "is BIOS device\n\t" : "",
				rsvf->drv & HASMAGFUNP ? "has MagiC3 funtable" : "");
		if (rsvf->drv & HASMAGFUNP) {
			magfuns = *((MAGICDEVDRV **)(rsvf->p.name - 4));
			printf("\tMagiC dev drv tab: %p\n", magfuns);
			if(argc > 1) {
				printf("\t\tmdev_open %p\n", magfuns->mdev_open);
				printf("\t\tmdev_close %p\n", magfuns->mdev_close);
				printf("\t\tmdev_read %p\n", magfuns->mdev_read);
				printf("\t\tmdev_write %p\n", magfuns->mdev_write);
				printf("\t\tmdev_stat %p\n", magfuns->mdev_stat);
				printf("\t\tmdev_lseek %p\n", magfuns->mdev_lseek);
				printf("\t\tmdev_datime %p\n", magfuns->mdev_datime);
				printf("\t\tmdev_ioctl %p\n", magfuns->mdev_ioctl);
				printf("\t\tmdev_delete %p\n", magfuns->mdev_delete);
				printf("\t\tmdev_getc %p\n", magfuns->mdev_getc);
				printf("\t\tmdev_getline %p\n", magfuns->mdev_getline);
				printf("\t\tmdev_putc %p\n", magfuns->mdev_putc);
			}	
		}
		rsvf++;
	}
  
  printf("end entry: %p, %x %d\n", rsvf->p.next, rsvf->drv, rsvf->devno);

  }	while(rsvf = rsvf->p.next);
	

	return(0);
}	/* main	*/

